var ELEMENT=1;
var TEXT=3;

function ws_escapeXML(s)
{
  var s1="";
  var i,I;
  for (i=0,I=s.length;i<I;++i)
  {
    var c=s.charAt(i);
    if (c=='>')
      s1+="&gt;";
    else if (c=='<')
      s1+="&lt;";
    else if (c=='&')
      s1+="&amp;";
    else
      s1+=c;
  }
  return s1;
}

function primParte(s)
{
  var d=0;
  if (s.charAt(0)=='/')
    d=1;
  var p=s.indexOf('/',d);
  if (p>0)
    return s.substring(0,p);
  else
    return s;
}

function ws_newXMLHttpRequest()
{
  var req;
  try
  {
    req=new XMLHttpRequest();
  }
  catch (e)
  {
    try
    {
      req=new ActiveXObject("MSXML2.XmlHttp");
    }
    catch (e)
    {
      try
      {
        req=new ActiveXObject("Microsoft.XmlHttp");
      }
      catch (e)
      {
        try
        {
          req=new ActiveXObject("MSXML.XmlHttp");
        }
        catch (e)
        {
          req=new ActiveXObject("MSXML3.XmlHttp");
        }
      }
    }
  }
  return req;
}

function ws_processResponseBody(req)
{
  var error,firstBodyChild;
  if (req.responseXML && req.responseXML.documentElement)
    error=ws_getFault(req.responseXML.documentElement);
  if (!error)
  {
    if (req.status !=200)
      error="El servidor devuelve error HTTP "+req.status+" "+req.statusText;
    else if (!req.responseXML || !req.responseXML.documentElement)
      error="El servidor no ha devuelto una respuesta XML";
  }
  if (!error)
  {
    firstBodyChild=ws_getFirstChildElement(ws_getChildElement(req.responseXML.documentElement,"Body"));
    if (!firstBodyChild)
      error="El servidor no ha devuelto un mensaje SOAP correcto";
  }
  if (error)
    throw error;
  return firstBodyChild;
}

function ws_getLocalName(e)
{
  // Moz: localName, IE: baseName
  return e.localName?e.localName:e.baseName;
}

function ws_getChildElement(e,nombre)
{
  if (!e)
    return null;

  var child;
  for (child=e.firstChild;child;child=child.nextSibling)
  {
    if (child.nodeType==ELEMENT && ws_getLocalName(child)==nombre)
      return child;
  }

  return null;
}

function ws_getFirstChildElement(e)
{
  if (!e)
    return null;

  var children=e.childNodes;
  var i;
  for (i=0;i<children.length;++i)
  {
    var child=children.item(i);
    if (child.nodeType==ELEMENT)
      return child;
  }
  return null;
}

function ws_getElementText(element)
{
  if (!element)
    return null;

  var text="";
  var node;
  for (node=element.firstChild;node!=null;node=node.nextSibling)
  {
    if (node.nodeType==TEXT)
      text+=node.nodeValue;
  }
  return text;
}

function ws_getFault(env)
{
  var fault=ws_getChildElement(ws_getChildElement(env,"Body"),"Fault");
  if (fault)
  {
    var eFaultCode=ws_getChildElement(fault,"faultcode");
    var eFaultString=ws_getChildElement(fault,"faultstring");
    var faultCode=eFaultCode?ws_getElementText(eFaultCode):"";
    var faultString=eFaultString?ws_getElementText(eFaultString):"";
    return "Error devuelto por el servidor: ("+faultCode+") "+faultString;
  }

  return null;
}

